#version 330 core

layout(location=1) in vec3 position;
layout(location=2) in vec3 normal;
layout(location=4) in vec3 color;

uniform mat4 modelView;
uniform mat4 perspective;
uniform mat3 normalMatrix;

out vec3 vf_viewPosition;
out vec3 vf_normal;
out vec3 vf_color;

void main(void)
{
	vec4 viewpos = modelView * vec4(position, 1.0);
	gl_Position = perspective * viewpos;
	vf_viewPosition = viewpos.xyz;
	vf_normal = normalMatrix * normal;
	vf_color = color;
}