#version 330 core

uniform sampler2D texture0;
uniform vec2 invImageSize;

in vec2 vf_texCoords;

out vec4 outColor;

void main(void)
{
	float total = texture2D(texture0, vf_texCoords+vec2(invImageSize.x,  invImageSize.y)).r;
	total +=      texture2D(texture0, vf_texCoords+vec2(invImageSize.x,  0)).r;
	total +=      texture2D(texture0, vf_texCoords+vec2(invImageSize.x,  -invImageSize.y)).r;
	total +=      texture2D(texture0, vf_texCoords+vec2(0,               invImageSize.y)).r;
	total +=      texture2D(texture0, vf_texCoords+vec2(0,               0)).r;
	total +=      texture2D(texture0, vf_texCoords+vec2(0,               -invImageSize.y)).r;
	total +=      texture2D(texture0, vf_texCoords+vec2(-invImageSize.x, invImageSize.y)).r;
	total +=      texture2D(texture0, vf_texCoords+vec2(-invImageSize.x, 0)).r;
	total +=      texture2D(texture0, vf_texCoords+vec2(-invImageSize.x, -invImageSize.y)).r;

	if (total > 4.5)
	{
		outColor = vec4(1.0,1.0,1.0,1.0);
	}
	else
	{
		outColor = vec4(0.0,0.0,0.0,1.0);
	}
}