#include "ColorMaterial.h"

ColorMaterial::ColorMaterial(const glm::vec3& color)
	: _color(color)
{
}

void ColorMaterial::setUniforms(Shader* shader)
{
	glUniform3f(shader->getUniformLocation("color"), _color.x, _color.y, _color.z);
}

const glm::vec3& ColorMaterial::getColor() const
{
	return _color;
}

void ColorMaterial::setColor(const glm::vec3& color)
{
	_color = color;
}