#ifndef _COLORMATERIAL_H_
#define _COLORMATERIAL_H_

#include "Material.h"
#include "glm/glm.hpp"

/**
	Simple material that contains one color to color an entire [MeshInstance](@ref MeshInstance)
*/
class ColorMaterial : public Material
{
public:
	ColorMaterial(const glm::vec3& color);

	const glm::vec3& getColor() const;
	void setColor(const glm::vec3& color);

	virtual void setUniforms(Shader* shader);

private:
	glm::vec3 _color;
};



#endif