#include "Geometry.h"
#include <algorithm>

void Geometry::createScreenQuad(Mesh* mesh, bool mirrorVertical)
{
	GLfloat screenQuadV[] = {
		-1.f,  1.f, .0f,
		-1.f, -1.f, .0f,
		 1.f,  1.f, .0f,
		 1.f, -1.f, .0f
	};

	GLfloat texCoord[8];
	if (mirrorVertical)
	{
		GLfloat screenQuadTC[] = {
			.0f, .0f,
			.0f, 1.f,
			1.f, .0f,
			1.f, 1.f
		};
		std::copy(screenQuadTC, screenQuadTC+8,texCoord);
	}
	else
	{
		GLfloat screenQuadTC[] = {
			.0f, 1.f,
			.0f, .0f,
			1.f, 1.f,
			1.f, .0f
		};
		std::copy(screenQuadTC, screenQuadTC+8,texCoord);
	}

	mesh->init(4, screenQuadV, nullptr, texCoord, GL_TRIANGLE_STRIP);
}