#include "Identifiable.h"

Identifiable::Identifiable()
	: _id(_idCounter++)
{
	_byID.resize(_id+1);
	_byID[_id] = this;
}

unsigned int Identifiable::getID()
{
	return _id;
}

Identifiable* Identifiable::byID(unsigned int id)
{
	if (id >= 0 && id < _byID.size())
		return _byID.at(id);
	return nullptr;
}

void Identifiable::hover() {}
UserAction Identifiable::press()
{
	return NO_CHANGE;
}

unsigned int Identifiable::_idCounter = 1;
std::vector<Identifiable*> Identifiable::_byID = std::vector<Identifiable*>(10, nullptr);