#include "InputHandler.h"

InputHandler::InputHandler()
{
	for (int i=0; i < GLFW_MOUSE_BUTTON_LAST; i++)
	{
		_buttonDown[i] = false;
		_buttonPressed[i] = false;
		_buttonReleased[i] = false;
	}
}

bool InputHandler::isMouseDown(int button)
{
	return _buttonDown[button];
}

bool InputHandler::isMousePressed(int button)
{
	return _buttonPressed[button];
}

bool InputHandler::isMouseReleased(int button)
{
	return _buttonReleased[button];
}

bool InputHandler::isKeyDown(int key)
{
	return _keyDown[key];
}

bool InputHandler::isKeyPressed(int key)
{
	return _keyPressed[key];
}

bool InputHandler::isKeyReleased(int key)
{
	return _keyReleased[key];
}

void InputHandler::update()
{
	for (int i=0; i < GLFW_MOUSE_BUTTON_LAST; i++)
	{
		if (glfwGetMouseButton(i))
		{
			_buttonReleased[i] = false;
			_buttonPressed[i] = !_buttonDown[i];
			_buttonDown[i] = true;
		}
		else
		{
			_buttonPressed[i] = false;
			_buttonReleased[i] = _buttonDown[i];
			_buttonDown[i] = false;
		}
	}

	for (int i=0; i < 256; i++)
	{
		if (glfwGetKey(i))
		{
			_keyReleased[i] = false;
			_keyPressed[i] = !_keyDown[i];
			_keyDown[i] = true;
		}
		else
		{
			_keyPressed[i] = false;
			_keyReleased[i] = _keyDown[i];
			_keyDown[i] = false;
		}
	}
}