#ifndef _MATERIAL_H_
#define _MATERIAL_H_

#include "Shader.h"

/**
	Base class for materials that can be applied to a [MeshInstance](@ref MeshInstance)
*/
class Material
{
public:
	/**
		Purely virtual function to set the shader uniforms of the material before a mesh is drawn.
	*/
	virtual void setUniforms(Shader* shader) = 0;
};


#endif