#include "SRTTransform.h"

SRTTransform::SRTTransform()
	: s(1.f), r(0.f,0.f,0.f), t(0.f,0.f,0.f), _transform()
{
}

SRTTransform::SRTTransform(float s, const glm::vec3& r, const glm::vec3& t)
	: s(s), r(r), t(t)
{
}

glm::mat4 SRTTransform::propagate(const glm::mat4& inhTransform, float inhScale, float* totalScale)
{
	*totalScale = inhScale * s;
	return inhTransform * _transform;
}

void SRTTransform::update()
{
	float cosRotX = cos(r.x);
	float sinRotX = sin(r.x);
	float cosRotY = cos(r.y);
	float sinRotY = sin(r.y);
	float cosRotZ = cos(r.z);
	float sinRotZ = sin(r.z);

	_transform = glm::mat4(
		s * cosRotY * cosRotZ, s * cosRotY * sinRotZ, s * (-sinRotY), .0f,
		s * (-cosRotX * sinRotZ + sinRotX * sinRotY * cosRotZ), s * (cosRotX * cosRotZ + sinRotX * sinRotY * sinRotZ), s * sinRotX * cosRotY, .0f,
		s * (sinRotX * sinRotZ + cosRotX * sinRotY * cosRotZ), s * (-sinRotX * cosRotZ + cosRotX * sinRotY * sinRotZ), s * cosRotX * cosRotY, .0f,
		t.x, t.y, t.z, 1.f
	);
}