#ifndef _SRTTRANSFORM_H_
#define _SRTTRANSFORM_H_

#include "Transform.h"

/**
	Calculates a matrix from a given translation vector, rotation vector and uniform scale factor.
*/
class SRTTransform : public Transform
{
public:
	SRTTransform();
	/**
		Creates a new transform that (from right to left) scales, rotates and translates
		@param s scale factor
		@param r pan, tilt, roll
		@param t translation vector
	*/
	SRTTransform(float s, const glm::vec3& r, const glm::vec3& t);

	virtual glm::mat4 propagate(const glm::mat4& inhTransform, float inhScale, float* totalScale);
	virtual void update();

	float s;
	glm::vec3 r;
	glm::vec3 t;

private:
	glm::mat4 _transform;
};


#endif _SRTTRANSFORM_H_