#include "StringUtil.h"
#include <algorithm>

using namespace std;

void StringUtil::tokenize(const string& str, vector<string>* tokens, const string& delim)
{
	size_t start = str.find_first_not_of(delim, 0);
	size_t end = str.find_first_of(delim, start);

	while(start != string::npos)
	{
		tokens->push_back(str.substr(start,end-start));

		start = str.find_first_not_of(delim, end);
		end = str.find_first_of(delim, start);
	}
}

string StringUtil::getBasePath(const string& str)
{
	size_t index = str.find_last_of("\\/");
	return (index==string::npos) ? str : str.substr(0,index);
}

string StringUtil::getFileName(const string& str)
{
	size_t index = str.find_last_of("\\/");
	return (index==string::npos) ? str : str.substr(index+1);
}

string StringUtil::getFileNameWithoutExtension(const string& str)
{
	size_t start = str.find_last_of("\\/");
	size_t end = str.find_last_of('.');
	if (start == string::npos)
	{
		return str.substr(0,end);
	}
	else
	{
		if (end == string::npos)
		{
			return str.substr(start+1);
		}
		else
		{
			return str.substr(start+1, end-start-1);
		}
	}
}

string StringUtil::toLowerCase(const string& str)
{
	string lower = str;
	std::transform(str.begin(), str.end(), lower.begin(), ::tolower);
	return lower;
}