#ifndef _STRING_UTIL_H_
#define _STRING_UTIL_H_

#include <string>
#include <vector>

/**
	Static methods for string processing
*/
class StringUtil
{
public:
	/**
		Splits `str` into substrings by the delimiter `delim`. Substrings are pushed back on `tokens`
	*/
	static void tokenize(const std::string& str, std::vector<std::string>* tokens, const std::string& delim=" ");
	static std::string getBasePath(const std::string& str);
	static std::string getFileName(const std::string& str);
	static std::string getFileNameWithoutExtension(const std::string& str);
	/**
		Transforms a string to lower case
	*/
	static std::string toLowerCase(const std::string& str);
};



#endif