#ifndef _TRANSFORMABLE_H_
#define _TRANSFORMABLE_H_

#include <glm/glm.hpp>

/**
	Interface for all types that can be appended to a `SceneNode`
*/
class Transformable
{
public:
	friend class SceneNode;

	Transformable();
	virtual ~Transformable();

	/**
		Sets the local transformation matrix of the object
	*/
	virtual void setTransform(const glm::mat4& transform) = 0;
	/**
		Returns the local transformation matrix of the object
	*/
	virtual const glm::mat4& getTransform() = 0;

	/**
		Returns the scene node that this object is attached to.
	*/
	SceneNode* getParent();
	
private:
	SceneNode* _parent;

	void setParent(SceneNode* parent);
};


#endif