#ifndef _FILEUTIL_H_
#define _FILEUTIL_H_

#include <string>

/**
	Provides generic file functions
*/
namespace fileutil
{
	/**
		Returns true iff the file `path` exists
		@param path relative or absolute name of a file
	*/
	bool fileExists(const std::string& path);
	/**
		Reads all contents of `path` and store into `buffer`.
		@param [in] path relative or absolute name of a text file
		@param [out] buffer contents of the file will be output here
	*/
	bool readFile(const std::string& path, std::string* buffer);
}


#endif